#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include "conv_base.h"
#include "tools.h"


#define DEBUG 0
#define DIR_LENGTH 300
/*
###########################################################################
# Args:
# 1 	name of machine
# 2 	working directory
# 3 	makefile 
# 4 	make target
###########################################################################
*/
int debug = 0; /*no debug mode here*/


int parseline(char *szLine , 
	          char *szFilename ,
	          char *szErrorinfo,
	          FILE * lfd
	          )
{
	
	char szToken[ 1024 ];
	char *stopstring;
	char *p1 = NULL;
	char *p2 = NULL;
	char *p3 = NULL;
	char *p4 = NULL;
	int nLinenum;
	/*find :line linenum format*/
	/*
	example:
	SCO
	"aaa.c", line 6: error:infomation...
	"aaa.c", line 6: warning:infomation...
	*/
	/*
	HP:
	Error 19: "CustomPlugin.cpp", line 697 # Unexpected '-'.
                    return -;
                           ^
	Error 362: "CustomPlugin.cpp", line 697 # Value expected for return statement;
    		function is not of void type.
                    return -;
	*/
	/*
	TRU64:
	
	cc: Warning: telnet.c, line 717: Non-void function "get_last_line" does not cont




cxx: Error: gettime.cpp, line 11: argument of type "long *" is incompatible
          
        */
	/*porc
	Error at line 48, column 10 in file /usr/include/wchar.h
	Syntax error at line 72, column 26, file /usr/include/gconv.h:
	*/
	p1 = (char *)strstr( szLine , " line ");
	memset(szToken , 0 , sizeof(szToken));
	memset(szErrorinfo , 0 , sizeof(szErrorinfo));
#ifdef DEBUG
	util_checkline(szLine , strlen( szLine ) + 1);
#endif
	/*is the next token is a number?*/
	if( p1 != NULL)
	{
		
		p2 = skipToNonWhite( p1 + 5 );/*a next nonwhite char after 'line'*/

		if( p2 && isdigit( *p2 ) )
		{
			
			if( ( nLinenum = strtod( p2 , &stopstring  ) ) != 0 
				|| ( *p2 == '0' && util_isOneOf(*(p2 + 1)," ," ) ) )
			{
				/*find the pro*c error message keyword:"in file "*/
				char szInFileKeyword[] = "in file ";
				p3 = strstr(szLine , szInFileKeyword);
				if(p3)/*pro*c*/
				{
					char *pDot = NULL;
					char Nextline[500];
					p3 += sizeof(szInFileKeyword) - 1;
					strcpy( szFilename , p3);
					/*sometimes pro*c split filename to 2 lines
					i.e.Syntax error at line 0, column 0, file /opt/oracle/product/9.0.1/precomp/demo/proc/sample1.pc:
					Error at line 0, column 0 in file /opt/oracle/product/9.0.1/precomp/demo/proc/sa
					mple1.pc
					PCC-S-02201, Encountered the symbol "<eof>" when expecting one of the following:
					I must check if there are a dot in filename , if it doesn't ,I must get the next line*/
					
					p4 = strrchr(p3 , '/');
					if(!p4)
						p4 = p3;
					pDot = strchr(p4 , '.');
					if(!pDot)
					{	
						memset(Nextline , 0 , sizeof(Nextline));
						util_getline( lfd , sizeof(Nextline) , Nextline);
						strcat(szFilename , Nextline);
					}
						
					
					
					/*there are no error info in the same line*/
					strcpy( szErrorinfo , "");
				}
				else  /*hp or tru64*/
				{
					int tru64 = 0;
					
					/*get the filename*/
					p3 = (char *)strchr( szLine , '\"');
					if(!p3 || p3 > p1 )
					{
						char szTmp[10];
						memset(szTmp , 0 , sizeof(szTmp));
						strcpy(szTmp, "Error:");
						p3 = (char *)strstr( szLine ,szTmp);
						
						if(!p3 || p3 > p1 )	
						{
							memset(szTmp , 0 , sizeof(szTmp));
							strcpy(szTmp, "Warning:");		
							p3 = (char *)strstr( szLine ,szTmp);
						}
						if(!p3 || p3 > p1 )	
							return -1;
						else 
						{
							p3 += strlen(szTmp) ;
							strncpy( szErrorinfo , szTmp , strlen(szTmp) - 1);
							szErrorinfo[strlen(szTmp) - 1] = '\0';
							tru64 = 1;
						}
					}
					if(tru64)
					{
						p4 = (char *)strchr( p3 + 1,',');
					}
					else
					{
						p4 = (char *)strchr( p3 + 1 , '\"');
					}
					if(!p4 || p4 > p1 )
					{
						
						return -1;
					}
					strncpy( szFilename , p3 + 1 , p4 - p3 - 1); 
					strcat( szErrorinfo , stopstring );
				}
				return nLinenum;
				
			}

		}
		else
			return -1;

	}
	else 
	{ 
	/*gcc output like this:*/
	/*
	filename.c:linenum:warning:infomation...
	filename.c:linenum: infomation...
	*/
	/*
	informix esqlc:
	test.ec:21: warning: overflow in implicit constant conversion
	test.ec:20: `dsdsa' undeclared (first use in this function)
	*/
	
	        /*modified by ken to adapt local path 'E:\xxx'*/
		p1 = (char *)strchr(szLine + 2, ':');
		if( !p1 )
			return -1;
/*
#ifdef DEBUG
		util_log("p1=%s\n",p1);
#endif
*/
		p2 = skipToNonWhite( p1 + 1);/*the next nonwhite char after ':'*/

		if( !p2 || !isdigit( *p2 ) )
		{
			return -1;
		}
/*
#ifdef DEBUG
		util_log("p2=%s\n",p2);
#endif
*/
		/*get the start of filename*/
		p3 = skipbackToWhite( szLine , p1 );
		if( ( nLinenum = strtod( p1 + 1 , &stopstring ) ) != 0 
				|| ( *p2 == 0 && *(p2 + 1) == ' ' ) )
		{
			/*get the filename*/
			strncpy( szFilename , p3 , p1 - p3 ); 
			strcpy( szErrorinfo , stopstring );
			return nLinenum;
		}
		
	} 
	return -1;
}
/*skip to next non white char*/
char * skipToNonWhite(char *chBegin )
{
	
	char *p = chBegin;
	/*
	if( *p == '\0' )
		return NULL;
		*/
	while( *p == ' ' || *p == '\t')
		p++;
	if( *p == '\0')
		return NULL;
	return p;
}

/*find the first whitespace before pEnd*/
char * skipbackToWhite(char *szBuf , char *pEnd)
{
	char *p = pEnd;
	while(p > szBuf)
	{
		p --;
		if( *p == ' ' || *p == '\t' )
		{
			p++;
			break;
		}
	}
	return p;
}
/*is it changed current working directory*/
/*just like :make[1]: Entering directory `/path/to/'*/
/*or Leaving directory `/path/to'*/
/*return zero for path has been changed*/
/*return 1 for path has been changed*/
int Checkdir (char *szLine ,char * szCurWorkdir ,char * szWorkdir ) 
{
	char *p = NULL;
	p = (char *)strstr( szLine , "Entering directory");
	if( p )
	{
		char *p1 = NULL;
		char *p2 = NULL;
		p1 = (char *)strchr( p , '`' );
		if( !p1 )
			return 0;
		p2 = (char *)strchr ( p1 + 1 , '\'' );
		if( !p2 )
			return 0;
		memset( szCurWorkdir , 0 , DIR_LENGTH );
		strncpy( szCurWorkdir , p1 + 1 , p2 - p1 - 1);
		/*the last char should not be '/'*/
		if( szCurWorkdir[ p2 - p1 - 2] == '/' )
			szCurWorkdir[ p2 - p1 - 2] = '\0';
		else
			szCurWorkdir[ p2 - p1 - 1] = '\0';
		return 1;
	}
	else if ( p = (char *)strstr( szLine , "Leaving directory") )
	{
		strcpy( szCurWorkdir , szWorkdir);
		return 1;
	}
	return 0;
	
}



